#!/bin/bash
#/program/AIRT40/AIRTfinder/AIRTfinder_exposure.sh

cd /program/AIRT40/AIRTfinder/



#(1)AIRTfinderによる撮像。露出時間を変えて9枚撮像
rm -rf /program/AIRT40/AIRTfinder/exposure/*.fits
night_exposure -t 0.121 -s on -b 1 -o /program/AIRT40/AIRTfinder/exposure/exposure001.fits
night_exposure -t 0.2 -s on -b 1 -o /program/AIRT40/AIRTfinder/exposure/exposure002.fits
night_exposure -t 0.4 -s on -b 1 -o /program/AIRT40/AIRTfinder/exposure/exposure003.fits
night_exposure -t 0.8 -s on -b 1 -o /program/AIRT40/AIRTfinder/exposure/exposure004.fits
night_exposure -t 1.6 -s on -b 1 -o /program/AIRT40/AIRTfinder/exposure/exposure005.fits
night_exposure -t 3.2 -s on -b 1 -o /program/AIRT40/AIRTfinder/exposure/exposure006.fits
night_exposure -t 6.4 -s on -b 1 -o /program/AIRT40/AIRTfinder/exposure/exposure007.fits
night_exposure -t 12.8 -s on -b 1 -o /program/AIRT40/AIRTfinder/exposure/exposure008.fits
night_exposure -t 25.6 -s on -b 1 -o /program/AIRT40/AIRTfinder/exposure/exposure009.fits



#(2)サチらない最適な露出時間を調べる
#(2.1)sextractorで星像のFWHMを抽出し、awkでFWHMのmedianを計算
rm -rf /program/AIRT40/AIRTfinder/sextractor/image_stat.dat
i=1
while [ $i -le 9 ]
do
    i=`printf "%03d" $i`
    cd /program/AIRT40/AIRTfinder/sexractor/
    sex /program/AIRT40/AIRTfinder/exposure/exposure$i.fits > /dev/null
    cd /program/AIRT40/AIRTfinder/
    awk -f /program/AIRT40/AIRTfinder/sextractor/image_stat.awk /program/AIRT40/AIRTfinder/sextractor/test.cat >> /program/AIRT40/AIRTfinder/sextractor/image_stat.dat
    i=`expr $i + 1`
done
rm -rf /program/AIRT40/AIRTfinder/sextractor/test.cat

#(2.2)awkでサチらない最適な露出時間を計算する
rm -rf /program/AIRT40/AIRTfinder/exposure/current.exposure
awk -f /program/AIRT40/AIRTfinder/exposure/best_exposure.awk /program/AIRT40/AIRTfinder/sextractor/image_stat.dat > /program/AIRT40/AIRTfinder/exposure/current.exposure

#(2.3)gnuplotによる表示(省略可)
rm -rf /program/AIRT40/AIRTfinder/exposure/best_exposure.plt
awk -f /program/AIRT40/AIRTfinder/exposure/best_exposure_gnuplot.awk /program/AIRT40/AIRTfinder/sexractor/image_stat.dat > /program/AIRT40/AIRTfinder/exposure/best_exposure.plt
gnuplot /program/AIRT40/AIRTfinder/exposure/best_exposure.plt



#(3)露出時間の判定
exposure_current=`awk '{print $1}' /program/AIRT40/AIRTfinder/exposure/current.exposure`
if [ $exposure_current -ne 10 ]
then
    #(3.1.1)露出時間が適切に決定できた場合
    #露出時間をlogファイルに記録
    echo "`date -u +"%Y/%m/%d_%H:%M:%S"`   $exposure_current" >> /program/AIRT40/AIRTfinder/exposure/log.exposure
    
    #(3.1.2)最適な露出時間で撮像
    rm -rf /program/AIRT40/AIRTfinder/exposure/best_exposure.fits
    night_exposure -t $exposure_current -s on -b 1 -o /program/AIRT40/AIRTfinder/exposure/best_exposure.fits

    #(3.1.3)このスクリプトを終了、戻り値0 (正常終了)
    exit 0
else

    #(3.2.1)露出時間を適切に決定できなかった場合(露出時間としては暫定値10secが代入されている)
    #logファイルに記録
    echo "exposure failure" >> /program/AIRT40/AIRTfinder/pointing/log.pointing
fi



#(4)このスクリプトを終了、戻り値1(露出時間を決めることが出来なかった)
exit 1
