#!/bin/bash
#/program/AIRT40/AIRTfinder/AIRTfinder_focus.sh

cd /program/AIRT40/AIRTfinder/

#現在のフォーカス位置を0と設定
last_focus=0



j=1
while [ $j -le 10 ]
do
    #(1)AIRTfinderによる撮像。フォーカスを動かして撮像する、を11回繰り返す
    #(1.1)フォーカス位置を-1.5mmへ移動
    /program/AIRT40/focus 1125

    #(1.2)撮像してフォーカス移動を+0.3mmを11回繰り返す(撮像は10sec、dark減算なし)
    rm -rf /program/AIRT40/AIRTfinder/focus/*.fits
    i=1
    while [ $i -le 11 ]
    do
        i=`printf "%03d" $i`
        night_exposure -t 10 -s on -b 1 -o /program/AIRT40/AIRTfinder/focus/focus$i.fits
        /program/AIRT40/focus -225
        i=`expr $i + 1`
    done

    #(1.3)フォーカスを開始位置へ戻す
    /program/AIRT40/focus 1350



    #(2)ピント位置を調べる
    #(2.1)sextractorで星像のFWHMを抽出し、awkで各画像のFWHMのmedianを計算
    rm -rf /program/AIRT40/AIRTfinder/sextractor/image_stat.dat
    i=1
    while [ $i -le 11 ]
    do
        i=`printf "%03d" $i`
        cd /program/AIRT40/AIRTfinder/sexractor/
        sex /program/AIRT40/AIRTfinder/focus/focus$i.fits > /dev/null
        cd /program/AIRT40/AIRTfinder/
        awk -f /program/AIRT40/AIRTfinder/sextractor/image_stat.awk /program/AIRT40/AIRTfinder/sextractor/test.cat >> /program/AIRT40/AIRTfinder/sextractor/image_stat.dat
        i=`expr $i + 1`
    done
    rm -rf /program/AIRT40/AIRTfinder/sextractor/test.cat

    #(2.2)awkでベストフォーカスの位置を計算する
    rm -rf /program/AIRT40/AIRTfinder/focus/command.focus
    awk -f /program/AIRT40/AIRTfinder/focus/best_focus.awk /program/AIRT40/AIRTfinder/sextractor/image_stat.dat > /program/AIRT40/AIRTfinder/focus/command.focus

    #(2.3)gnuplotによる表示(省略可)
    rm -rf /program/AIRT40/AIRTfinder/focus/best_focus.plt
    awk -f /program/AIRT40/AIRTfinder/focus/best_focus_gnuplot.awk /program/AIRT40/AIRTfinder/sexractor/image_stat.dat > /program/AIRT40/AIRTfinder/focus/best_focus.plt
    gnuplot /program/AIRT40/AIRTfinder/focus/best_focus.plt



    #(3)フォーカス位置の判定
    #ベストフォーカス位置が元々の値と+/-0.1mm以下の位置にあれば既に合焦しているとみなす
    focus_command=`awk '{print $2}' /program/AIRT40/AIRTfinder/command.focus`
    if [ $focus_command -le 75 ]
    then
        if [ $focus_command -ge -75 ]
        then
            #(3.1.1)on focusであることをlogファイルに記録
            echo "`date -u +"%Y/%m/%d_%H:%M:%S"`   $last_focus" >> /program/AIRT40/AIRTfinder/focus/log.focus

            #(3.1.2)on focus画像を取得
            rm -rf /program/AIRT40/AIRTfinder/focus/on_focus.fits
	    night_exposure -t 10 -s on -b 1 -o /program/AIRT40/AIRTfinder/focus/on_focus.fits

            #(3.1.3)このスクリプトを終了、戻り値0 (正常終了)
            exit 0
        else
            :
        fi
    else
        :
    fi

    #現在のピントがベストフォーカスでない場合
    #(3.2.1)フォーカスの移動
    /program/AIRT40/AIRTfinder/focus/command.focus

    #(3.2.2)last_focusを更新
    last_focus=`expr -- $last_focus + $focus_command`

    #(3.2.3)logファイルに記録
    echo "now be focusing" >> /program/AIRT40/AIRTfinder/focus/log.focus


    j=`expr $j + 1`
done



#(4.1)logファイルに記録
echo "focus failure" >> /program/AIRT40/AIRTfinder/focus/log.focus

#(4.2)このスクリプトを終了、戻り値1(ピントは合わなかった)
exit 1
