#!/bin/bash
#/program/AIRT40/AIRTfinder/AIRTfinder_pointing.sh

cd /program/AIRT40/AIRTfinder/

#露出時間を読み込む
exposure=`awk '{print $1}' /program/AIRT40/AIRTfinder/exposure/current.exposure`
#視野中心の定義の読み込み
xorg=`awk '{print $1}' /program/AIRT40/AIRTfinder/exposure/original.pointing`
yorg=`awk '{print $2}' /program/AIRT40/AIRTfinder/exposure/original.pointing`



j=1
while [ $j -le 10 ]
do

    #(1)AIRTfinderによる撮像。5枚。
    rm -rf /program/AIRT40/AIRTfinder/pointing/*.fits
    i=1
    while [ $i -le 5 ]
    do
        i=`printf "%03d" $i`
        night_exposure -t $exposure -s on -b 1 -o /program/AIRT40/AIRTfinder/pointing/pointing$i.fits
        i=`expr $i + 1`
    done



    #(2)星の位置を調べる
    #(2.1)sextractorで星の位置を決定し、awkで各画像で最も明るい星のX,Yを抽出
    rm -rf /program/AIRT40/AIRTfinder/sextracawkでFWHMのmedianを計算tor/image_stat.dat
    i=1
    while [ $i -le 5 ]
    do
        i=`printf "%03d" $i`
        cd /program/AIRT40/AIRTfinder/sexractor/
        sex /program/AIRT40/AIRTfinder/pointing/pointing$i.fits > /dev/null
        cd /program/AIRT40/AIRTfinder/
        awk -f /program/AIRT40/AIRTfinder/sextractor/image_stat.awk /program/AIRT40/AIRTfinder/sextractor/test.cat >> /program/AIRT40/AIRTfinder/sextractor/image_stat.dat
        i=`expr $i + 1`
    done
    rm -rf /program/AIRT40/AIRTfinder/sextractor/test.cat

    #(2.2)awkで最も明るい星の座標(X,Y)のメジアンを計算し、current.pointingに保存
    rm -rf /program/AIRT40/AIRTfinder/pointing/current.pointing
    awk -f /program/AIRT40/AIRTfinder/pointing/current_pointing.awk /program/AIRT40/AIRTfinder/sextractor/image_stat.dat > /program/AIRT40/AIRTfinder/pointing/current.pointing

    #(2.3)gnuplotによる表示(省略可)
    cat /program/AIRT40/AIRTfinder/pointing/current.pointing >> /program/AIRT40/AIRTfinder/pointing/tmp.pointing
    gnuplot /program/AIRT40/AIRTfinder/pointing/current_pointing.plt



    #(3)視野中心との差分をawk計算で計算し、望遠鏡に送るコマンドを作成
    rm -rf /program/AIRT40/AIRTfinder/pointing/command.pointing
    paste /program/AIRT40/AIRTfinder/pointing/original.pointing /program/AIRT40/AIRTfinder/pointing/current.pointing > /program/AIRT40/AIRTfinder/pointing/tmp2.pointing
    awk -f /program/AIRT40/AIRTfinder/pointing/command_pointing.awk /program/AIRT40/AIRTfinder/pointing/tmp2.pointing > /program/AIRT40/AIRTfinder/pointing/command.pointing
    rm -rf /program/AIRT40/AIRTfinder/pointing/tmp2.pointing



    #(4)もしcurrent positionとoriginal positionの差が10pix^2=100未満の場合、ループを抜ける
    xcur=`awk '{print $1}' /program/AIRT40/AIRTfinder/pointing/current.pointing`
    ycur=`awk '{print $2}' /program/AIRT40/AIRTfinder/pointing/current.pointing`
    delta=`echo "scale=0; (($xorg-$xcur)^2+($yorg-$ycur)^2)/1" | bc`
    if test $delta -lt 100
    then
        #(4.1.1)on pointであることをlogファイルに記録
        echo "`date -u +"%Y/%m/%d_%H:%M:%S"`   $delta" >> /program/AIRT40/AIRTfinder/pointing/log.pointing

 	#(4.1.2)sincコマンドを送る (オプション)
	#/program/LX200/meade :CM# -r 4       

        #(4.1.3)on focus画像を取得
        rm -rf /program/AIRT40/AIRTfinder/pointing/on_point.fits
	night_exposure -t $exposure -s on -b 1 -o /program/AIRT40/AIRTfinder/pointing/on_point.fits

        #(4.1.4)このスクリプトを終了、戻り値0 (正常終了)
        exit 0

    else
        :
    fi

    #現在の天体位置がベストフォーカスでない場合
    #(4.2.1)望遠鏡を駆動
    /program/AIRT40/AIRTfinder/pointing/command.pointing

    #(4.2.2)logファイルに記録
    echo "now be pointing" >> /program/AIRT40/AIRTfinder/pointing/log.pointing


    j=`expr $j + 1`
done



#(4.1)gnulpot用のデータを削除
rm -rf /program/AIRT40/AIRTfinder/pointing/tmp.pointing

#(4.2)logファイルに記録
echo "point failure" >> /program/AIRT40/AIRTfinder/pointing/log.pointing

#(4.3)このスクリプトを終了、戻り値1(視野中心に導入出来なかった)
exit 1
