# best_focus.awk
# awk -f best_focus.awk image_stat.dat
#
# CALCULATE "BEST FOCUS POSITION"

BEGIN{
    n=0
#フォーカスの開始位置を設定(m=?)
    m=-1.5
    A1=A2=A3=s4=s2=s0=0.0
}

{
    FWHMmed[n]=$1
    X[n]=m
    n++
#フォーカス移動の刻み幅を設定(m=m+?)
    m=m+0.3
    N=n
}

END{
    for(i=0; i<N; i++){
        s4=s4+X[i]*X[i]*X[i]*X[i]
        s2=s2+X[i]*X[i]
        s0=N
        A1=A1+X[i]*X[i]*FWHMmed[i]
        A2=A2+X[i]*FWHMmed[i]
        A3=A3+FWHMmed[i]
    }
    
#最小二乗法で求めた2次関数の係数
    a=s0/(s4*s0-s2*s2)*A1-s2/(s4*s0-s2*s2)*A3
    b=1/s2*A2
    c=-s2/(s4*s0-s2*s2)*A1+s4/(s4*s0-s2*s2)*A3
    x=-b/2.0/a
    x2=-750*x

#最小二乗法で求めた1次関数の係数
    d=1/s2*A2
    e=1/s0*A3

#フォーカス位置を上記の係数から判定しfocusコマンドを出力
    if(a<=0){
        if(d>0)           printf("/program/AIRT40/focus 1125\n")
        else              printf("/program/AIRT40/focus -1125\n")
    }
    else{
        if(x<=-1.5)       printf("/program/AIRT40/focus 1125\n")
        else if(x<=1.5)   printf("/program/AIRT40/focus %.0f\n",x2)
        else              printf("/program/AIRT40/focus -1125\n")
    }
}
